%  beamplot.m                    T.L.Szabo    Version 1          4/10/06
% for Diagnostic Ultrasound Imaging: Inside Out by Thomas L. Szabo
% This program calaculates beamplots vs angle for
% different apodizations, and line apertures, focal lengths and distances
% in terms of wavelengths (zhat =distance of beamplot in wavelengths)
% different plot choices and one way & round trip options
%
close;
close;
%
disp('select number for type of plot');
disp('1=normal with half-beamwidths in degrees');
disp('2=compare two plots side by side');
disp('4=compare two curves on same plot');
disp('5=compare two round trip curves on same plot');
compare=input('type in selected plot number: ');
%
%    create large loop capability for multiple cases
%
loop=1;
if (compare==5), loop=2; end;
%
for i=1:loop
%
disp('select number for type of apodization');
disp('1=unapodized');
disp('2=full Hamming');
disp('3=truncated Hamming, B=0.75');
disp('14=Gaussian');
nap=input('type in first (or only) apodization type number: ');

%
if (compare~=1),
   nap2=input('type in  second apodization type number: ');
end;
%
%  determine angular plot width
%%if (i == 1), wide=input('type in 0 (normal=+/-45 deg),1 (narrow=+/-10 deg),2 (+/-20 deg),3 (wide=+/-90 deg)');
wide=0;
end;
%
% initialize constants
ii=sqrt(-1.);
dzhat=50.;
dhat=0.5;
zmin=20.;
n=256;
m=64;
fhat=50000.;
m=input('type number of array elements spaced at half wavelength intervals: ');
lhat=m*dhat;
%  type input parameters
fhat=input('type focusing distance in wavelengths (use >=50,000 for no focus): ');
zhat=input('type axial distance z for beamplot in wavelengths: ');
c=ones(1,n);
oo=ones(1,m);
e=1.e-3;
nmax=1-2/n;
xn=-1:2/n:nmax;
xx=asin(xn)*180.0/pi;
%thetax=asin(xn);
%xx=zhat*tan(thetax);
%
%  constrain angular extent as required
if(wide == 0), xx=xx(38:220);
elseif(wide == 1), xx=xx(106:152);
elseif(wide == 2), xx=xx(85:173);
else;
end;
% change x nov8 10:20am 
%  old x=linspace(-m/2,m/2-1,m);
x=linspace(-(m-1)/2,(m-1)/2,m);
x2=linspace(-m/4,m/4-1,m/2);
xhat=dhat*x;
if zhat==fhat;ph=xhat*0.0;end;
if zhat~=fhat;ph=pi*xhat.*xhat.*(1/zhat-1/fhat);end;
%
%  create input selectable plot of
%  an apodization function and its beamplot
%
%  select function
%
%  UNAPODIZED
if (nap == 1),
   ux=ones(1,m);
   ua=ux.*exp(-ii*ph)/sqrt(zhat);
   u=abs(fftshift(fft(ua,n)));
   umax=max(u);
   u=u/umax;
   ul=20.0*log10(u+e*c);
   yy=oo;xy=ul;
%
%  FULL HAMMING
elseif (nap == 2),
   a=.54+.46*cos(pi*x*2/m);
   ua=a.*exp(-ii*ph)/sqrt(zhat);
   am=abs(fftshift(fft(ua,n)));
   amax=max(am);
   am=am/amax;
   al=20.0*log10(am+e*c);
   yy=a;xy=al;

%   TRUNC HAMMING B=0.75
elseif (nap == 3),
   t=.54+.46*cos(pi*x*4/(3.*m));
   ua=t.*exp(-ii*ph)/sqrt(zhat);
   tm=abs(fftshift(fft(ua,n)));
   tmax=max(tm);
   tm=tm/tmax;
   tl=20.0*log10(tm+e*c);
   yy=t;xy=tl;
%
%   GAUSSIAN WITH M=2
elseif (nap == 4),
    xpon=x/12.5;
    g2=exp(-xpon.^2);
    g2m=abs(fftshift(fft(g2,n)));
    g2max=max(g2m);
    g2m=g2m/g2max;
    g2l=20.0*log10(g2m+e*c);
    yy=g2;xy=g2l;
%
%
else;
end;
%
%   second selection
if (compare~=1),
%  create input selectable plot of
%  an apodization function and its beamplot
%
%  select function
%
%  UNAPODIZED
  if (nap2 == 1),
   u=abs(fftshift(fft(ones(1,m),n)));
   umax=max(u);
   u=u/umax;
   ul=20.0*log10(u+e*c);
   yy2=oo;xy2=ul;
%
%  FULL HAMMING
  elseif (nap2 == 2),
   a=.54+.46*cos(pi*x*2/m);
   am=abs(fftshift(fft(a,n)));
   amax=max(am);
   am=am/amax;
   al=20.0*log10(am+e*c);
   yy2=a;xy2=al;

%   TRUNC HAMMING B=0.75
  elseif (nap2 == 3),
   t=.54+.46*cos(pi*x*4/(3.*m));
   tm=abs(fftshift(fft(t,n)));
   tmax=max(tm);
   tm=tm/tmax;
   tl=20.0*log10(tm+e*c);
   yy2=t;xy2=tl;
%
%   GAUSSIAN WITH M=2
elseif (nap2 == 4),
    xpon=x/12.5;
    g2=exp(-xpon.^2);
    g2m=abs(fftshift(fft(g2,n)));
    g2max=max(g2m);
    g2m=g2m/g2max;
    g2l=20.0*log10(g2m+e*c);
    yy2=g2;xy2=g2l;
%
else;
  end;
%  windup multiple cases loop by defining outputs
     if(i == 1), xyt=xy+xy2;
     elseif (i == 2),xyt2=xy+xy2;
     else;
     end;
end;
%%%end;
%
%  master plots section
%
%  normal plot
if (compare==0),
elseif (compare==1),
%    determine apodization beamwidths
%
yinc6=(m-1)/2;
yinc0=0.0;
for i1= 1:(m-1)/2,
    xest=interp1(x,yy,i1);
    if(xest <= .5),
       yinc0=i1-2;
       break;
       end;
    end;
for ii= 1:25,
    yinc=ii*0.1+yinc0;
    xest=interp1(x,yy,yinc);
    if(xest <= 0.505 & xest >= .495),
       yinc6=yinc;
%   elseif(xest <= 0.105 & xest >= 0.095),yinc10=yinc;
       break,
       else;
       end;
    end;
  subplot(2,1,1),plot(x,yy,'m');title(['APODIZATION =',num2str(nap)]);xlabel('elements');
  ylabel('linear');
  text(15,0.8,['-6dB BW/2 =',num2str(yinc6)]);
%  text(20.,0.6,['-10dB BW/2 =',num2str(yinc10)]);
  %
  %   prepare for beamwidth text positions
  %
      if(wide == 0), xy=xy(38:220);xpos=15.;xposa=-40.;
      elseif(wide == 1), xy=xy(106:152);xpos=7.;
      elseif(wide == 2), xy=xy(85:173);xpos=10;
      else;xpos=30.;
      end;
      ypos=10.; yposa=0.;
      ypos2=0.; ypos2a=-10.;
      ypos3=-10.; ypos3a=-20.;
      ypos4=-20.; ypos4a=-30.;
%
%    determine beamwidths
%
    for i= 1:1600,
    xinc=i*0.01;
    yest=interp1(xx,xy,xinc);
    if(yest >= -6.1 & yest <= -5.90),
       xinc6=xinc;
    elseif(yest >= -10.1 & yest <= -9.90),xinc10=xinc;
    elseif(yest >= -20.1 & yest <= -19.90),xinc20=xinc;
    elseif(yest >= -40.1 & yest <= -39.90),xinc40=xinc;
       break,
       end;
    end;
  subplot(2,1,2),plot(xx,xy,'k');title('BEAMPLOT');xlabel('angle(deg.)');
  ylabel('dB');
  text(xpos,ypos,['-6dB BW/2 =',num2str(xinc6)]);
  text(xpos,ypos2,['-10dB BW/2 =',num2str(xinc10)]);
  text(xpos,ypos3,['-20dB BW/2 =',num2str(xinc20)]);
  %text(xpos,ypos4,['-40dB BW/2 =',num2str(xinc40)]);
  text(xposa,ypos,['Lhat =',num2str(lhat)]);
  text(xposa,ypos2,['Fhat =',num2str(fhat)]);
  text(xposa,ypos3,['Zhat =',num2str(zhat)]);
%  
%  extra plot for book
figure;
plot(xx,xy,'k');title('BEAMPLOT');
xlabel('angle(deg.)');  ylabel('dB');
  text(xpos,yposa,['-6dB BW/2 =',num2str(xinc6)]);
  text(xpos,ypos2a,['-10dB BW/2 =',num2str(xinc10)]);
  text(xpos,ypos3a,['-20dB BW/2 =',num2str(xinc20)]);
  %text(xpos,ypos4a,['-40dB BW/2 =',num2str(xinc40)]);
  text(xposa,yposa,['Lhat =',num2str(lhat)]);
  text(xposa,ypos2a,['Fhat =',num2str(fhat)]);
  text(xposa,ypos3a,['Zhat =',num2str(zhat)]);
%
%  side by side
elseif (compare==2),
  subplot(2,2,1),plot(x,yy,'m');title(['APODIZATION =',num2str(nap)]);xlabel('elements');
  ylabel('linear');
      if(wide == 0), xy=xy(38:220);
      elseif(wide == 1), xy=xy(106:152);
      elseif(wide == 2), xy=xy(85:173);
      else;
      end;
  subplot(2,2,3),plot(xx,xy,'m');title('BEAMPLOT');xlabel('angle(deg.)');
  ylabel('dB');
  subplot(2,2,2),plot(x,yy2,'c');title(['APODIZATION =',num2str(nap2)]);xlabel('elements');
  ylabel('linear');
      if(wide == 0), xy2=xy2(38:220);
      elseif(wide == 1), xy2=xy2(106:152);
      elseif(wide == 2), xy2=xy2(85:173);
      else;
      end;
  subplot(2,2,4),plot(xx,xy2,'c');title('BEAMPLOT');xlabel('angle(deg.)');
  ylabel('dB');
%  side by side & round trip plot
elseif (compare==3),
  subplot(2,2,1),plot(x,yy,'m');title(['APODIZATION =',num2str(nap)]);xlabel('elements');
  ylabel('linear');
      if(wide == 0), xy=xy(38:220);
      elseif(wide == 1), xy=xy(106:152);
      elseif(wide == 2), xy=xy(85:173);
      else;
      end;
  subplot(2,2,3),plot(xx,xy,'m');title('BEAMPLOT');xlabel('angle(deg.)');
  ylabel('dB');
  subplot(2,2,2),plot(x,yy2,'c');title(['APODIZATION =',num2str(nap2)]);xlabel('elements');
  ylabel('linear');
      if(wide == 0), xy2=xy2(38:220);
      elseif(wide == 1), xy2=xy2(106:152);
      elseif(wide == 2), xy2=xy2(85:173);
      else;
      end;
  subplot(2,2,4),plot(xx,xy2,'c');title('BEAMPLOT');xlabel('angle(deg.)');
  ylabel('dB');
%  open figure for round trip plot
  figure;
      if(wide == 0), xyt=xyt(38:220);xpos=15.;
      elseif(wide == 1), xyt=xyt(106:152);xpos=5.;
      elseif(wide == 2), xyt=xyt(85:173);xpos=10;
      else;xpos=30.;
      end;
      ypos=-10.;
      ypos2=-20.;
      ypos3=-30.;
      ypos4=-40.;
%
%    determine beamwidths
%
    for i= 1:600,
    xinc=i*0.005;
    yest=interp1(xx,xyt,xinc);
    if(yest >= -6.05 & yest <= -5.95),
       xinc6=xinc;
    elseif(yest >= -10.05 & yest <= -9.95),xinc10=xinc;
    elseif(yest >= -20.05 & yest <= -19.95),xinc20=xinc;
    elseif(yest >= -40.05 & yest <= -39.95),xinc40=xinc;
       break,
       end;
    end;
  plot(xx,xyt,'c');title('ROUND TRIP BEAMPLOT');xlabel('angle(deg.)');
  text(xpos,ypos,['-6dB BW/2 =',num2str(xinc6)]);
  text(xpos,ypos2,['-10dB BW/2 =',num2str(xinc10)]);
  text(xpos,ypos3,['-20dB BW/2 =',num2str(xinc20)]);
  text(xpos,ypos4,['-40dB BW/2 =',num2str(xinc40)]);
%
elseif (compare==4),
  subplot(2,1,1),plot(x,yy,'m',x,yy2,'c');title(['APODIZATION =',num2str(nap),'and',num2str(nap2)]),xlabel('elements');
  ylabel('linear');
      if(wide == 0), xy=xy(38:220); xy2=xy2(38:220);
      %%if(wide == 0), xy=xy(38:220); xy2=xy2(38:220);
      elseif(wide == 1), xy=xy(106:152); xy2=xy2(106:152);
      elseif(wide == 2), xy=xy(85:173);  xy2=xy2(85:173);
      else;
      end;
  subplot(2,1,2),plot(xx,xy,'m',xx,xy2,'c');title(['BEAMPLOTS magenta = ',num2str(nap),'cyan=',num2str(nap2)]);xlabel('angle(deg.)');
  ylabel('dB');
%  open figure for round trip plot
elseif (compare==5),
      %if(wide == 0), xyt2=xyt2(38:220);
      if(wide == 0), xyt=xyt(38:220); xyt2=xyt2(38:220);
      elseif(wide == 1), xyt=xyt(106:152); xyt2=xyt2(106:152);
      elseif(wide == 2), xyt=xyt(85:173);  xyt2=xyt2(85:173);
      else;
      end;
  plot(xx,xyt,'m',xx,xyt2,'c');title('ROUND TRIP BEAMPLOTS magenta = case 1,cyan= case 2');
  xlabel('angle(deg.)');
  ylabel('dB');
else;
end;
%%%end
