%  fig41.m                   T.L.Szabo              9/12/02
% this program calculates frequency independent loss on 3 scales
% creates  figure 4.1 in Diagnostic Ultrasound Imaging: Inside Out
% 
close all;
clear all;
zdelt0=2.;            %  time sample increment
nt=20;               %  number of time points
z=zdelt0*(0:nt-1);     %  time array (us)

alfa1=0.1151;         % nepers/MHz/cm = 1 dB/MHz/cm
f0=2.;              %  center frequency in MHz
%z=0.135;                 % distance in centimeters
z2=0.675;
z3=1.35;
c0=.15;             % sound speed reference (cm/us) or midband value
fc=5.;  %  center frequency
%
loss1=exp(-alfa1*z);
loss2=log(loss1);
loss3=20*log10(loss1);
figure;subplot(3,1,1);
plot(z,loss1);
ylabel('exp(-alfaz)');
subplot(3,1,2);
plot(z,loss2);
ylabel('alfa(nepers)z');
subplot(3,1,3);
plot(z,loss3);
xlabel('z(cm)'); ylabel('alfa(dB)');